// Timer.h
//------------------------------------------------------------------------------
#pragma once
#ifndef CORE_TIME_TIMER_H
#define CORE_TIME_TIMER_H

// Includes
//------------------------------------------------------------------------------
#include <Core/Env/Types.h>

// Timer
//------------------------------------------------------------------------------
class Timer
{
public:
	Timer() { Start(); }
	inline ~Timer() {}

	inline void Start() { m_StartTime = GetNow(); }
	inline void Start( float time ) { m_StartTime = GetNow() - (uint64_t)( (double)GetFrequency() * (double)time ); }

	float GetElapsed() const
	{
		uint64_t now = GetNow();
		return (float)( (double)( now - m_StartTime ) / (double)GetFrequency() );
	}

	static uint64_t GetNow();
	static inline uint64_t GetFrequency() { return 1000; }

private:
	uint64_t m_StartTime;
};

//------------------------------------------------------------------------------
#endif // CORE_TIME_TIMER_H
